<template>
  <q-layout view="lHh Lpr lFf">
    <q-header elevated>
      <q-toolbar>
        <q-btn
          flat
          dense
          round
          icon="menu"
          aria-label="Menu"
          @click="toggleLeftDrawer"
          color="secondary"
        />


        <q-toolbar-title class="text-secondary">
          <a href="/" class="text-bold">
            Gloupbook
          </a>
        </q-toolbar-title>

        <q-input filled v-model="text" label="Recherche" :dense="dense" bg-color="white" color="secondary" class="mobile-hide">
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>

        <a href="/#/login" class="q-ml-lg">
          <q-btn color="secondary" icon="person" label="Se connecter" />
        </a>
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="leftDrawerOpen"
      bordered
      class="bg-primary"
    >
      <q-img src="../assets/images/gloupbook-removebg-preview.png">
        <!--        <div class="absolute-bottom bg-transparent">-->
        <!--          <div class="text-secondary">-->
        <!--            Un monde-->
        <!--          </div>-->
        <!--        </div>-->
      </q-img>

      <q-list>
        <EssentialLink
          v-for="link in linksList"
          :key="link.title"
          v-bind="link"
        />
      </q-list>


      <div class="q-pa-md q-gutter-sm absolute-bottom-right">
        <poster-dialog />
      </div>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import EssentialLink, { EssentialLinkProps } from 'components/EssentialLink.vue';
import PosterDialog from 'components/PosterDialog.vue';

defineOptions({
  name: 'MainLayout'
});

import { defineProps } from 'vue';

const props = defineProps<{
  alreadyOpened: boolean;
}>();

const linksList: EssentialLinkProps[] = [
  {
    title: 'Accueil',
    caption: 'Page d\'accueil',
    icon: 'home',
    link: '/'
  },
  {
    title: 'Explorer',
    caption: 'Explorer les articles',
    icon: 'explore',
    link: '/explore'
  },
  {
    title: 'À propos',
    caption: 'En savoir plus',
    icon: 'info',
    link: '/about'
  },
  {
    title: 'Contact',
    caption: 'Nous contacter',
    icon: 'email',
    link: '/contact'
  },
  {
    title: 'Profil',
    caption: 'Voir votre profil',
    icon: 'person',
    link: '/profile'
  },
  {
    title: 'Déconnexion',
    caption: 'Se déconnecter',
    icon: 'logout',
    link: '/logout'
  }
];

const leftDrawerOpen = ref(props.alreadyOpened || false);

function toggleLeftDrawer() {
  leftDrawerOpen.value = !leftDrawerOpen.value;
}

const text = ref('');
const dense = ref(true);
</script>

<style lang="scss">
// reset link styles
a {
  text-decoration: none;
  color: inherit;
}
</style>
